diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 13061a6d8..2acd63740 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.type;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.world.World;
@@ -41,7 +42,7 @@ public abstract class WorldType
     private final int maxY;
     private final int maxPortalY;
     private final int oceanY;
-    private final int oceanBlockId;
+    private final int[] oceanBlockIds;
     private final int fillerBlockId;
     private final int dayNightCycleTicks;
     private final boolean mayRespawn;
@@ -66,7 +67,14 @@ public abstract class WorldType
             this.maxPortalY = this.maxY;
         }
         this.oceanY = properties.oceanY;
-        this.oceanBlockId = properties.oceanBlock == null ? 0 : properties.oceanBlock.id();
+        if (properties.oceanBlocks.isEmpty()) {
+            this.oceanBlockIds = new int[] { Blocks.AIR.id() };
+        } else {
+            this.oceanBlockIds = new int[properties.oceanBlocks.size()];
+            for (int i = 0; i < properties.oceanBlocks.size(); i++) {
+                this.oceanBlockIds[i] = properties.oceanBlocks.get(i).id();
+            }
+        }
         this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id();
         this.dayNightCycleTicks = properties.dayNightCycleTicks;
         this.mayRespawn = properties.mayRespawn;
@@ -122,8 +130,8 @@ public abstract class WorldType
         return oceanY;
     }
 
-    public int getOceanBlockId() {
-        return oceanBlockId;
+    public int[] getOceanBlockIds() {
+        return oceanBlockIds;
     }
 
     public int getFillerBlockId() {
@@ -314,7 +322,7 @@ public abstract class WorldType
         private int maxY = 255;
         private Integer maxPortalY = null;
         private int oceanY = 128;
-        private @Nullable Block<?> oceanBlock = null;
+        private @NotNull List<Block<?>> oceanBlocks = new ArrayList<>();
         private @Nullable Block<?> fillerBlock = null;
         private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
         private boolean mayRespawn = false;
@@ -389,8 +397,9 @@ public abstract class WorldType
             return this;
         }
 
-        public @NotNull Properties oceanBlock(Block<?> oceanBlock) {
-            this.oceanBlock = oceanBlock;
+        public @NotNull Properties oceanBlocks(Block<?>... oceanBlocks) {
+            this.oceanBlocks.clear();
+            this.oceanBlocks.addAll(Arrays.asList(oceanBlocks));
             return this;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 026509a68..539333335 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -73,7 +73,7 @@ public abstract class WorldTypes {
         new WorldTypeOverworldFloating(
             WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
                 .bounds(0, 255, 0)
-                .oceanBlock(null)
+                .oceanBlocks()
                 .withTags(WorldTypeTags.OVERWORLD)
         )
     );
@@ -125,7 +125,7 @@ public abstract class WorldTypes {
                     .withSingleSeason(Seasons.OVERWORLD_HELL)
                     .build()
                 )
-                .oceanBlock(Blocks.FLUID_LAVA_STILL)
+                .oceanBlocks(Blocks.FLUID_LAVA_STILL)
                 .fillerBlock(Blocks.STONE)
                 .allowRespawn()
                 .bounds(0, 127, 64)
@@ -160,7 +160,7 @@ public abstract class WorldTypes {
         new WorldTypeOverworldInland(
             WorldTypeOverworld.defaultProperties("worldType.overworld.inland")
                 .bounds(0, 255, 0)
-                .oceanBlock(null)
+                .oceanBlocks()
                 .withTags(WorldTypeTags.OVERWORLD)
         )
     );
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 3ef04360f..da9180de2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -19,7 +19,7 @@ public class WorldTypeNether
     public static Properties defaultProperties(String translationKey) {
         return Properties.of(translationKey)
                 .brightnessRamp(getLightRamp())
-                .oceanBlock(Blocks.FLUID_LAVA_STILL)
+                .oceanBlocks(Blocks.FLUID_LAVA_STILL, Blocks.FLUID_WATER_STILL)
                 .fillerBlock(Blocks.COBBLE_NETHERRACK)
                 .withCeiling()
                 .bounds(0, 255, 64 + 32);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index 453d831db..b7dd03970 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -37,7 +37,7 @@ public class WorldTypeOverworld extends WorldType {
                 .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
             )
-            .oceanBlock(Blocks.FLUID_WATER_STILL)
+            .oceanBlocks(Blocks.FLUID_WATER_STILL)
             .fillerBlock(Blocks.STONE)
             .allowRespawn();
     }
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index 0368825e8..0b340f245 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -497,4 +497,17 @@ item.rubyglass.crystal.pure.name=Rubyglass
 item.rubyglass.crystal.pure.desc=A shard of charged Rubyglass crystal, brimming with energy. Perfectly intact and slightly translucent.
 
 item.sulfur.name=Sulfur
-item.sulfur.desc=Highly flammable and yellow. Packs a punch.
\ No newline at end of file
+item.sulfur.desc=Highly flammable and yellow. Packs a punch.
+
+item.armor.wolf.leather.name=Leather Wolf Armor
+item.armor.wolf.leather.desc=Keep your best friend safe with this soft leather shell.
+item.armor.wolf.chainmail.name=Chainmail Wolf Armor
+item.armor.wolf.chainmail.desc=Keep your best friend safe with this tough chainmail shell. Can be repaired.
+item.armor.wolf.iron.name=Iron Wolf Armor
+item.armor.wolf.iron.desc=Keep your best friend safe with this strong iron shell.
+item.armor.wolf.diamond.name=Diamond Wolf Armor
+item.armor.wolf.diamond.desc=Keep your best friend safe with this fancy diamond shell.
+item.armor.wolf.gold.name=Gold Wolf Armor
+item.armor.wolf.gold.desc=Keep your best friend fabulous with this shiny gold shell.
+item.armor.wolf.steel.name=Steel Wolf Armor
+item.armor.wolf.steel.desc=Keep your best friend safe with this sturdy steel shell.
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 944946b8d..19b25d8a9 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -31,6 +31,7 @@ class WorkbenchGenerator {
         generateChestPlates();
         generateLeggings();
         generateBoots();
+        generateWolfArmors();
 
         generateBlockCompression();
         generateBlockDecompression();
@@ -686,6 +687,22 @@ class WorkbenchGenerator {
         boots.addInput('X', Items.INGOT_STEEL).create("steel_boots", Items.ARMOR_BOOTS_STEEL.getDefaultStack());
     }
 
+    private static void generateWolfArmors() {
+        RecipeBuilderShaped armor = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setAllowMirrored(true)
+            .setShape(
+                " XX",
+                "XXX",
+                "X X"
+            );
+
+        armor.addInput('X', Items.LEATHER).create("leather_wolf_armor", Items.ARMOR_WOLF_LEATHER.getDefaultStack());
+        armor.addInput('X', Items.INGOT_IRON).create("iron_wolf_armor", Items.ARMOR_WOLF_IRON.getDefaultStack());
+        armor.addInput('X', Items.INGOT_GOLD).create("gold_wolf_armor", Items.ARMOR_WOLF_GOLD.getDefaultStack());
+        armor.addInput('X', Items.DIAMOND).create("diamond_wolf_armor", Items.ARMOR_WOLF_DIAMOND.getDefaultStack());
+        armor.addInput('X', Items.INGOT_STEEL).create("steel_wolf_armor", Items.ARMOR_WOLF_STEEL.getDefaultStack());
+    }
+
     private static void generateBlockCompression() {
         RecipeBuilderShaped block = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1348,6 +1365,7 @@ class WorkbenchGenerator {
          Registries.RECIPES.WORKBENCH.register("repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
          Registries.RECIPES.WORKBENCH.register("repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
          Registries.RECIPES.WORKBENCH.register("repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+         Registries.RECIPES.WORKBENCH.register("repair_chainmail_wolf",        new RecipeEntryRepairable(Items.ARMOR_WOLF_CHAINMAIL.getDefaultStack(),         new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
     }
 
     private static void generateToolRecipes() {
